"""Утилиты"""
import json

from .variables import MAX_PACKAGE_LENGTH, ENCODING


def get_message(client):
    """
    Утилита приёма и декодирования сообщения
    принимает байты, выдаёт словарь, если принято что-то другое отдаёт ошибку значения
    :param client:
    :return:
    """
    encoded_response = client.recv(MAX_PACKAGE_LENGTH)
    if isinstance(encoded_response, bytes):
        json_responce = encoded_response.decode(ENCODING)
        response = json.loads(json_responce)
        if isinstance(response, dict):
            return response
        raise ValueError
    raise ValueError


def send_message(sock, message):
    """
    Утилита кодирования и отправки сообщения
    принимает словарь и отправляет его
    :param sock:
    :param message:
    :return:
    """

    json_message = json.dumps(message)
    encoded_message = json_message.encode(ENCODING)
    sock.send(encoded_message)
